MEMORY
{
  ram (rwx) : ORIGIN = 0x20000000, LENGTH = 8K
  rom (rx)  : ORIGIN = 0x08000000, LENGTH = 128K
}
SECTIONS
{
    .  = 0x08000000;         /* From 0x08000000 */
    .text : 
    {
        KEEP(*(vectors))    /* Vector table */
	*(.text .text.*)	/* Program code */
	*(.gnu.linkonce.t.*)
	*(.glue_7)
	*(.glue_7t)
	*(.gcc_except_table)
	*(.rodata .rodata*)	/* Read only data */
	*(.gnu.linkonce.r.*)
    } >rom

    .eh_frame_hdr :
    {
	*(.eh_frame_hdr)
    } >rom                                                                                  

    .eh_frame : ONLY_IF_RO
    {
	KEEP (*(.eh_frame))
    } >rom                                                                       

    .ctors :
    {
	. = ALIGN(4);
	PROVIDE(__ctors_start = .);
	KEEP(*(SORT(.ctors.*)))
	KEEP(*(.ctors))
	PROVIDE(__ctors_end = .);
    } >rom

    .dtors :
    {
	. = ALIGN(4);
	PROVIDE(__dtors_start = .);
	KEEP(*(SORT(.dtors.*)))
	KEEP(*(.dtors))
	PROVIDE(__dtors_end = .);

	. = ALIGN(4);
	/* End Of .text section */
	_etext = .;
        _sifastcode = .;
    } >rom

    .fastcode :
    {
	. = ALIGN (4);
	_sfastcode = . ;

	*(.glue_7t) *(.glue_7)
	*(.fastcode)
          
	/* add other modules here ... */

	. = ALIGN (4);
	_efastcode = . ;
	_sidata = .;
    } >ram AT >rom

    .  = 0x20000000;  /* From 0x20000000 */      
    .data : 
    {
	. = ALIGN(4);
	_sidata = LOADADDR (.data); /* Start inicializacnich hodnot ve FLASH (LMA) */
	_sdata = .;			/* Kam se odkazuje na data CPU za behu (VMA) RAM */

	*(vtable vtable.*)
	*(.data .data.*)	/* Data memory */
	*(.gnu.linkonce.d*)

	. = ALIGN(4);
	_edata = . ;
    } >ram AT >rom

    .bss :
    {
	. = ALIGN(4);
	_sbss = . ;

	*(.bss .bss.*)		/* Zero-filled run time allocate data memory */
	*(.gnu.linkonce.b*)
	*(COMMON)

	. = ALIGN(4);
	_ebss = . ;

	. = ALIGN(4);
	_end = . ;
	PROVIDE (end = .);
    } >ram
} 
